/**
 * Cleversafe open-source code header - Version 1.1 - December 1, 2006
 *
 * Cleversafe Dispersed Storage(TM) is software for secure, private and
 * reliable storage of the world's data using information dispersal.
 *
 * Copyright (C) 2005-2007 Cleversafe, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 *
 * Contact Information: Cleversafe, 10 W. 35th Street, 16th Floor #84,
 * Chicago IL 60616
 * email licensing@cleversafe.org
 *
 * Author: Greg Dhuse <gdhuse@cleversafe.com>
 *
 */

#ifndef DSDNET_WIN_H
#define DSDNET_WIN_H

#include "dsd_win_common.h"
#include <ntstrsafe.h>

#define DSDNET_TAG "dsdnet:"

/* Communication */
NTSTATUS DsdNetConnect( IN uint32_t ipAddr, 
                        IN uint16_t port, 
                        OUT int* socket );

NTSTATUS DsdNetShutdown( IN WDFDEVICE device );
NTSTATUS DsdNetClose( IN WDFDEVICE device );

NTSTATUS DsdNetRecv( IN WDFDEVICE device, 
                     OUT uint8_t** data, 
                     OUT uint8_t* msgType );

NTSTATUS DsdNetSend( IN WDFDEVICE device, 
                     IN uint8_t msgType, 
                     IN uint8_t* data, 
                     IN int len );

NTSTATUS DsdNetSendAtomic( IN WDFDEVICE device, 
                           IN uint8_t msgType, 
                           IN uint8_t* data, 
                           IN int len );

#endif
